#include <stdio.h>
/*#define NDEBUG*/
#include <assert.h>

#define MODULUS 32999


#define max(a,b) (((a) > (b)) ? (a) : (b))
#define MAX 30

int newton[MAX+1][MAX+1];


int N;
int T[MAX+1];
#ifndef NDEBUG
int C[MAX];
#endif




int pos;
#ifndef NDEBUG
int min;
#endif

void parse(int par, int *cnt, int *n)
{
  int curr = pos;
  int lc, rc;
  int tmp1, tmp2, tmp3;

  assert(T[curr] > min);
  *cnt = 0;
  *n = 1;
  if (T[pos] < par)
  {
    pos++;
    parse(T[curr], &lc, &tmp1);
#ifndef NDEBUG
    min = T[curr];
#endif
    parse(par, &rc, &tmp2);
    *cnt = lc+rc+1;
    tmp3 = (tmp1*newton[lc+rc][lc])%MODULUS;
    *n = (tmp3*tmp2)%MODULUS;
  }
}


int main()
{
  int i, j;
  int d;
 
  
  for (i = 0; i <= MAX; i++)
  {
    newton[i][0] = newton[i][i] = 1;
    for (j = 1; j < i; j++)
    {
      newton[i][j] = (newton[i-1][j]+newton[i-1][j-1])%MODULUS;
    }
  }

  scanf("%d", &d);
  while (d--)
  {
    int cnt;
    int n;
   
    cnt = scanf("%d", &N);
    assert(cnt == 1);
    assert(N >= 1 && N <= 30);
#ifndef NDEBUG
    for (i = 0; i < N; i++)
      C[i] = 0;
    min = 0;
#endif
    for (i = 0; i < N; i++)
    {
      scanf("%d", &T[i]);
      assert(T[i] >= 1 && T[i] <= N);
      assert(!C[T[i]-1]);
#ifndef NDEBUG
      C[T[i]-1] = 1;
#endif
    }
    T[N] = N+1;
    pos = 0;
    parse(N+1, &cnt, &n);

    printf("%d\n", n);
  }
  

  return 0;
}

