/*
Rozwiazanie do zadania Binary Search Tree dla pelnej reprezentacji
wyniku (nie tylko modulo 32999).
*/

#include <stdio.h>
/*#define NDEBUG*/
#include <assert.h>

typedef int BIGNUM[100];

#define max(a,b) (((a) > (b)) ? (a) : (b))
#define MAX 30

BIGNUM newton[MAX+1][MAX+1];
int newtl[MAX+1][MAX+1];


int N;
int T[MAX+1];
#ifndef NDEBUG
int C[MAX];
#endif



void print(BIGNUM n, int nl)
{
  int i;
  for (i = nl-1; i >= 0; i--)
    printf("%d", n[i]);
  if (nl == 0)
    printf("0");
}

void add(BIGNUM n1, BIGNUM n2, int *pn1l, int n2l)
{
  int sum, c;
  int i;
  int n1l = *pn1l;

  c = 0;
  *pn1l = 0;
  for (i = 0; i <= max(n1l, n2l); i++)
  {
    sum = ((i<n1l)?n1[i]:0)+((i<n2l)?n2[i]:0)+c;
    if (sum > 0)
      *pn1l = i+1;
    n1[i] = sum%10;
    c = sum/10;
  }
}

void copy(BIGNUM n1, BIGNUM n2, int *pn1l, int n2l)
{
  int i;
  for (i = 0; i < n2l; i++)
    n1[i] = n2[i];
  *pn1l = n2l;
}


void mul(BIGNUM n1, BIGNUM n2, BIGNUM res, int n1l, int n2l, int *resl)
{
  BIGNUM temp;
  int *t;
  int tl;
  int sum, c;
  int i, j;

  *resl = 0;
  for (i = 0; i < n1l; i++)
  {
    for (j = 0; j < i; j++)
      temp[j] = 0;
    t = temp+i;
    c = 0;
    tl = 0;
    for (j = 0; j <= n2l; j++)
    {
      sum = ((j<n2l)?n2[j]:0)*n1[i]+c;
      if (sum > 0)
        tl = j+1;
      t[j] = sum%10;
      c = sum/10;
    }
    tl += i;
    add(res, temp, resl, tl);
  }
}

void set1(BIGNUM n, int *pnl)
{
  n[0] = 1;
  *pnl = 1;
}



int pos;
#ifndef NDEBUG
int min;
#endif

void parse(int par, int *cnt, BIGNUM n, int *nl)
{
  int curr = pos;
  int lc, rc;
  BIGNUM tmp1, tmp2, tmp3;
  int t1l, t2l, t3l;

  assert(T[curr] > min);
  *cnt = 0;
  set1(n, nl);
  if (T[pos] < par)
  {
    pos++;
//printf("Lewi synowie %d:\n", T[curr]);
    parse(T[curr], &lc, tmp1, &t1l);
//printf("Prawi synowie %d:\n", T[curr]);
#ifndef NDEBUG
  min = T[curr];
#endif
    parse(par, &rc, tmp2, &t2l);
    *cnt = lc+rc+1;
    mul(newton[lc+rc][lc], tmp1, tmp3, newtl[lc+rc][lc], t1l, &t3l);
    mul(tmp2, tmp3, n, t2l, t3l, nl);
//printf("Wynik dla %d: cnt=%d n=", T[curr], *cnt);
//print(n, *nl);
//printf("\n");
  }
}


int main()
{
  int i, j;
  int d;
  
  
  for (i = 0; i <= MAX; i++)
  {
    set1(newton[i][0], &newtl[i][0]);
    set1(newton[i][i], &newtl[i][i]);
    for (j = 1; j < i; j++)
    {
      copy(newton[i][j], newton[i-1][j], &newtl[i][j], newtl[i-1][j]);
      add(newton[i][j], newton[i-1][j-1], &newtl[i][j], newtl[i-1][j-1]);
    }
    /*
    for (j = 0; j <= i; j++)
    {
      print(newton[i][j], newtl[i][j]);
      printf(" ");
    }
    printf("\n");
    */
  }

  scanf("%d", &d);
  while (d--)
  {
    int cnt;
    BIGNUM n;
    int nl;
   
    cnt = scanf("%d", &N);
    assert(cnt == 1);
    assert(N >= 1 && N <= 30);
#ifndef NDEBUG
    for (i = 0; i < N; i++)
      C[i] = 0;
    min = 0;
#endif
    for (i = 0; i < N; i++)
    {
      scanf("%d", &T[i]);
      assert(T[i] >= 1 && T[i] <= N);
      assert(!C[T[i]-1]);
#ifndef NDEBUG
      C[T[i]-1] = 1;
#endif
    }
    T[N] = N+1;
    pos = 0;
    parse(N+1, &cnt, n, &nl);

    print(n, nl);
    printf("\n");
  }
  

  return 0;
}

